<?php
/**
 *
 * @category        admintool
 * @package         secure-admin
 * @author          Ruud Eisinga - www.dev4me.com
 * @link			https://www.dev4me.com/
 * @license         https://www.gnu.org/licenses/gpl.html
 * @platform        WebsiteBaker 2.8.x
 * @version         0.3
 * @lastmodified    September 3, 2021
 *
 */

if(defined('WB_PATH') == false) { die("Cannot access this file directly"); }

$varexist = file_exists(WB_PATH.'/var/');

$modPath = str_replace('\\', '/', dirname(__FILE__)).'/';
if(!is_readable($modPath.'languages/'.LANGUAGE .'.php')) {
	require_once($modPath.'languages/EN.php');
} else {
	require_once($modPath.'languages/'.LANGUAGE .'.php');
}
$iplist = $_SERVER['REMOTE_ADDR']."\n";
if(file_exists(ADMIN_PATH.'/.htaccess')) {
	$htaccess = file(ADMIN_PATH.'/.htaccess');
	foreach ($htaccess as $line) {
		if (stripos($line,"allow from ") !== false) {
			preg_match("/\d{1,3}\.\d{1,3}\.\d{1,3}\.\d{1,3}/", $line, $matches); 
			$found = $matches[0];
			if ($found != $_SERVER['REMOTE_ADDR'])
				$iplist .= $found."\n";
		}
	}
}

if($doSave) {
	if (!$admin->checkFTAN()) {
		if(!$admin_header) $admin->print_header(); 
		$admin->print_error($MESSAGE['GENERIC_SECURITY_ACCESS'], $_SERVER['REQUEST_URI'] );
		exit();
	} else {
		
		$new_iplist = explode("\r\n", $admin->get_post_escaped('iplist'));
/* 		
		$new_htaccess  = "AuthUserFile /dev/null \n";
		$new_htaccess .= "AuthGroupFile /dev/null \n";
		$new_htaccess .= "AuthName \"Access Control\" \n";
		$new_htaccess .= "AuthType Basic \n";
 */		
		$new_htaccess .= "order deny,allow \n";
		$new_htaccess .= "deny from all \n";
		$new_htaccess .= "# Allow access for these IP addresses \n";
		$own = false;
		foreach($new_iplist as $ip) {
			if($ip && filter_var($ip, FILTER_VALIDATE_IP)) {
				if ($ip == $_SERVER['REMOTE_ADDR']) $own = true;
				$new_htaccess .= "allow from $ip \n";
			}
		}
		if(!$own) $new_htaccess .= "allow from ".$_SERVER['REMOTE_ADDR']."\n";
		file_put_contents(ADMIN_PATH.'/.htaccess', $new_htaccess);
		if($varexist) {
			if(isset($_POST['vartoo'])) {
				file_put_contents(WB_PATH.'/var/.htaccess', $new_htaccess);
			} elseif (file_exists(WB_PATH.'/var/.htaccess')) {
				unlink ( WB_PATH.'/var/.htaccess' );
			}
		}
		if(isset($_POST['temptoo'])) {
			file_put_contents(WB_PATH.'/temp/.htaccess', $new_htaccess);
		} elseif (file_exists(WB_PATH.'/temp/.htaccess')) {
			unlink ( WB_PATH.'/temp/.htaccess' );
		}
		if(!$admin_header) $admin->print_header(); 
		$admin->print_success($TEXT['SUCCESS'], $_SERVER['REQUEST_URI'] );
		exit();
	}			
} 
?>
<h2><?php echo $MOD_SA['HEADING']; ?> <br/><span><?php echo $MOD_SA['SUBHEADING']; ?></span></h2>
<hr/>
<form name="store_settings" action="<?php echo $_SERVER['REQUEST_URI'];?>" method="post">
	<?php echo $admin->getFTAN(); ?>
	<input type="hidden" name="tool" value="<?= basename(__DIR__); ?>" />
	<input type="hidden" name="action" value="save" />
	<input type="hidden" name="SaveSettings" value="1" />
	  
	<strong><?php echo $MOD_SA['IPLIST'];?></strong><br/>
	<i><?php echo $MOD_SA['HELP1'];?></i><br/>
	<i><?php echo $MOD_SA['HELP2'];?></i><br/><br/>
	<textarea class="iplist" rows="10" cols="80" name="iplist"><?php echo $iplist ?></textarea>
	<?php if($varexist) { ?>
	<p><input name="temptoo" type="checkbox"  value="1" checked /> <strong><?php echo $MOD_SA['TEMPTOO']; ?></strong></p>
	<p><input name="vartoo" type="checkbox"  value="1" checked /> <strong><?php echo $MOD_SA['VARTOO']; ?></strong></p>
	<?php } ?>
	<p><?php echo $MOD_SA['NOTE']; ?></p>
	<p><input type="submit" style="margin-top:10px; width:140px;" value="<?php echo $TEXT['SAVE']; ?>" /></p>
</form>
<?php 
